package game.gui;

import game.color.TextColor;
import game.gui.element.ActButton;
import game.gui.element.TransparentBox;
import game.init.Config;

public class GuiInfo extends Gui {
	private static final String INFO = 
	TextColor.GREEN + "" + TextColor.BUG + "" + TextColor.BUG + "" + TextColor.BUG + " " + TextColor.VIOLET + "" + Config.VERSION + "" + 
	TextColor.GREEN + " " + TextColor.BUG + "" + TextColor.BUG + "" + TextColor.BUG + "\n" + 
	"\n" + 
	TextColor.LGRAY + "Ein kleine Anwendung zur Simulation, zum Testen, für Spiele, Musik und vieles" + "\n" + 
	"mehr. Optimiert für Geschwindigkeit, Stabilität und" + TextColor.UNKNOWN + "" + TextColor.UNKNOWN + " [Speicherzugriffsfehler]" + "\n" + 
	"\n" + 
	TextColor.CYAN + "Geschrieben von Sen dem \"kleinen\" Dämonen " + TextColor.CRIMSON + TextColor.DEMON + TextColor.BLACK + TextColor.BLKHEART + "\n" + 
	"\n" + 
	TextColor.YELLOW + "Verwendete Programmbibliotheken:" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "LWJGL 3.3.6+1 (GLFW + OpenGL)" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "Netty 4.1.119-Final" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "Guava 33.4.0" + "\n" + 
	TextColor.LGRAY + "  -> " + TextColor.NEON + "tjglu (Modifiziert: LWJGL 2.9.4-nightly-20150209)" + "\n" + 
//	"\n" + 
//	TextColor.YELLOW + "Verwendeter Compiler: " + "\n" + 
//	TextColor.LGRAY + "  -> " + TextColor.NEON + BUILD_COMP + "\n" + 
//	"\n" + 
//	TextColor.YELLOW + "Kompiliert auf System: " + "\n" + 
//	TextColor.LGRAY + "  -> " + TextColor.NEON + BUILD_SYS + "\n" + 
	"\n" + 
	"\n" + 
	TextColor.BLACK + "#0 " + TextColor.DGRAY + "#1 " + TextColor.GRAY + "#2 " + TextColor.LGRAY + "#3 " + TextColor.WHITE + "#4 " + TextColor.RED + "#5 " + TextColor.GREEN + "#6 " + 
	TextColor.BLUE + "#7 " + TextColor.YELLOW + "#8 " + TextColor.MAGENTA + "#9 " + TextColor.CYAN + "#A " + TextColor.VIOLET + "#B " + TextColor.ORANGE + "#C " + TextColor.CRIMSON + "#D " + 
	TextColor.MIDNIGHT + "#E " + TextColor.NEON + "#F " + TextColor.BROWN + "#G " + TextColor.DBROWN + "#H " + TextColor.DGREEN + "#I " + TextColor.DRED + "#J " + TextColor.DMAGENTA + "#K " + 
	TextColor.DVIOLET + "#L " + TextColor.ORK + "#M " + TextColor.ACID + "#N ";
	
	private static final String[] AUTHORS = {"Sen"};

	public static final GuiInfo INSTANCE = new GuiInfo("Über dieses Programm", INFO);

	private final String header;
	private final String info;

	private static void addLines(StringBuilder sb, boolean hax, String alternate, String category, String... authors) {
		sb.append((hax ? TextColor.BLUE : TextColor.GRAY) 
				+ (hax ? alternate : category) + ":\n");
		sb.append((hax ? TextColor.DVIOLET : TextColor.WHITE) + "    ");
		for(String author : authors) {
			if(sb.length() > 0)
				sb.append(", ");
			sb.append(author);
		}
		sb.append("\n");
	}

	private static String getCredits(boolean hax) {
		StringBuilder sb = new StringBuilder();
		sb.append("    " + (hax ? TextColor.CYAN : TextColor.WHITE) + "=============================\n");
		sb.append("    " + (hax ? TextColor.RED : TextColor.YELLOW) + (hax ? "Das Team -- TCQ" : "Mitwirkende") + "\n");
		sb.append("    " + (hax ? TextColor.CYAN : TextColor.WHITE) + "=============================\n");
		sb.append("\n");
		addLines(sb, hax, "Absolut größter Lamer des Universums", "Ursprünglich erstellt von", 
				"Markus Persson");
		addLines(sb, hax, "Crack und weitere Programmierung", "Spiel-Design, Programmierung und Grafiken", 
				"Jens Bergensten", "Nathan Adams", "Ryan Holtz", "Michael Stoyke");
		addLines(sb, hax, "Ressourcen entschlüsselt von", "Programmierung", 
				"Erik Broes", "Paul Spooner", "Ryan Hitchman", "Elliot Segal");
		addLines(sb, hax, "Cracktro, Grafiken und Intromusik", "Töne und Geräusche", 
				"Daniel Rosenfeld", "freesound.org");
		addLines(sb, hax, "Packing und Verbreitung", "Management, Administration und Spaß", 
				"Carl Manneh", "Daniel Kaplan", "Lydia Winters");
		addLines(sb, hax, "Server und Hosting", "Zahlen und Statistiken", 
				"Patrick Geuder");
		addLines(sb, hax, "Weiterer Dank geht an", "Entwickler von Mo' Creatures (Pferde usw.)", 
				"John Olarte", "Kent Christian Jensen", "Dan Roque");
		addLines(sb, hax, "Genutzte Exploits", "Weiterer Quellcode", 
				"Albert Pham - WorldEdit", "Joonas Vali - NameGenerator");
		addLines(sb, hax, "Der dunkle Herrscher", "Mod erstellt von", 
				AUTHORS);
		addLines(sb, hax, "Verwendete Programme und Tools", "Verwendete Technologien", 
				"Java 8 (Sun, Oracle)", "LWJGL 2", "JOrbis (JCraft)", "\"3D Sound System\" (Paul Lamb)");
		return sb.toString();
	}
	
	public GuiInfo(String header, String info) {
		this.header = header;
		this.info = info;
	}
	
	public void init(int width, int height) {
		this.add(new TransparentBox(0, 0, width, height - 24, this.info));
		this.add(new ActButton(0, height - 24, width, 24, GuiMenu.INSTANCE, "Zurück"));
	}
	
	public String getTitle() {
		return this.header;
	}
}
